// ===========================================================================
// SamyConsole II 1.0 by geo650, 2015-03-07
// ===========================================================================

#include <fcntl.h>
#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>
#include <sys/mman.h>
#include <pthread.h>
#include <netdb.h>
#include <unistd.h>
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include "buttons.h"
#include "telnetd.c"
#include "usbhid.c"
#include "scancodes.c"
#include "samyconsole2.h"

// ---------------------------------------------------------------------------

char path[MAX_PATH];
char old_path[MAX_PATH];
int is_console_window = 0;
int SDL_was_init = 0;
SDL_Surface *screen;
SDL_Surface *fonts;
SDL_VideoInfo *videoinfo;
SDL_Rect fontrect;
Uint32 screen_color;
Uint32 cursor_color;
Uint32 IPs_color;
Uint32 curpos_color;
int background_alpha;
char host[MAX_HOSTLEN+1];
int hostlen;
int port;
char IPs_now[16];
char *ESCSEQ = "\033[";
char ttyp[MAX_TTYP];
int kbqueue[KB_QUEUE_SIZE];
int kbqueue_head;
int kbqueue_tail;
int kbqueue_len;
int kbqueue_lock;
char buffer[MAXDATASIZE+1];
int buffer_len;
char cbuf[MAX_CBUFLEN];
int cbuf_write;
int cbuf_read;
int cbuf_len;
typedef struct { int x; int y; } curpos;
curpos cur, ANSI_saved_cur, tmp_cur, win;
int cursor_visible;
int entering_adr;
char tabstops[CONSOLE_COLUMNS];
char console_buffer[CONSOLE_COLUMNS * CONSOLE_LINES + 1];
int special;
int sockfd = -1;
pthread_t ID_comm_thread;
int comm_thread_is_running = 0;
int abort_comm_thread;
pthread_t ID_input_thread;
int input_thread_is_running = 0;
int abort_input_thread;
pthread_t ID_keyboard_thread;
int keyboard_thread_is_running = 0;
int abort_keyboard_thread;

// ---------------------------------------------------------------------------

int datasend(int *sockfd, char *buf, int bytes_to_send)
{
   int bytes_sent;
  if (*sockfd == -1) return 1;
   if (bytes_to_send > 0)
   {
      if ((bytes_sent = send(*sockfd, buf, bytes_to_send, 0)) == -1) return 1;
      if (bytes_sent != bytes_to_send) return 2;
   }
   return 0;
}

void stop_comm_thread(int *sockfd)
{
   int timeout = 100;
   char EXIT_CMD[] = {3, 'e','x','i','t',13};
   if (*sockfd != -1) datasend(sockfd, EXIT_CMD, 6);
   abort_comm_thread = 1;
   while (comm_thread_is_running && (timeout--)) SDL_Delay(DELAY_THREAD);
   if (timeout <= 0) pthread_cancel(ID_comm_thread);
}

void stop_input_thread(int *sockfd)
{
   int timeout = 100;
   abort_input_thread = 1;
   while (input_thread_is_running && (timeout--)) SDL_Delay(DELAY_THREAD);
   if (timeout <= 0) pthread_cancel(ID_input_thread);
}

void change_alpha(SDL_Rect *dstrect, unsigned char A)
{
   int i, h;
   unsigned char *scr;
   h = dstrect->h;
   if (screen)
   {
      SDL_LockSurface(screen);
      scr = screen->pixels + dstrect->y * screen->pitch + dstrect->x * (SCREEN_BPP/8) + 3;
      while (h > 0)
      {
  for (i = 0; i < dstrect->w; i++) { *(scr) = A; scr += (SCREEN_BPP/8); }
  scr += screen->pitch - dstrect->w * (SCREEN_BPP/8);
  h--;
      }
      SDL_UnlockSurface(screen);
   }
}

void change_text_color_and_alpha(SDL_Rect *dstrect, Uint32 *newcolor, unsigned char newalpha)
{
   int i, h;
   Uint32 *scr;
   Uint32 pixel, newc;
   newc = (*newcolor & 0x00FFFFFF) | (newalpha << 24);
   h = dstrect->h;
   if (screen)
   {
      SDL_LockSurface(screen);
      scr = (Uint32 *)(screen->pixels + dstrect->y * screen->pitch + dstrect->x * (SCREEN_BPP/8));
      while (h > 0)
      {
  for (i = 0; i < dstrect->w; i++)
  {
     pixel = *scr;
     if ((pixel & 0x00FFFFFF) > 0x00F0F0F0) *scr = newc;
     scr++;
  }
  scr += screen->pitch/(SCREEN_BPP/8) - dstrect->w;
  h--;
      }
      SDL_UnlockSurface(screen);
   }
}

void console_textout(int x, int y, char *text, int flip)
{
   int i, ln, ch;
   SDL_Rect dstrect;
   ln = strlen(text);
   if (ln < 1) return;
   if (!screen) return;
   dstrect.w = CHARWIDTH;
   dstrect.h = CHARHEIGHT;
   for (i = 0; i < ln; i++)
   {
       ch = *(text++);
       dstrect.x = win.x + (CONSOLE_LMARGIN + x++) * CHARWIDTH;
       dstrect.y = win.y + y * LINEHEIGHT;
       SDL_FillRect(screen, &dstrect, screen_color);
       change_alpha(&dstrect, background_alpha);
       fontrect.y = CHARHRASTER * (ch >> 4);
       fontrect.x = CHARWRASTER * (ch - 16 * (ch >> 4)) + CHARSHIFT;
       SDL_BlitSurface(fonts, &fontrect, screen, &dstrect);
       if (x >= MAX_X) { x = 0; y++; if (y >= MAX_Y) y = 0; }
   }
   if (flip) SDL_Flip(screen);
}

void scroll_screen_up()
{
   int scanline;
   SDL_Rect dstrect;
   if (!screen) return;
   SDL_LockSurface(screen);
   for (scanline = 0; scanline < (CONSOLE_LINES-1) * LINEHEIGHT; scanline++)
       memcpy(screen->pixels + (win.y + scanline + CONSOLE_SHIFT * LINEHEIGHT) * screen->pitch + (win.x + CONSOLE_LMARGIN*CHARWIDTH) * (SCREEN_BPP/8),
       screen->pixels + (win.y + scanline + (CONSOLE_SHIFT+1) * LINEHEIGHT) * screen->pitch + (win.x + CONSOLE_LMARGIN*CHARWIDTH) * (SCREEN_BPP/8),
       CONSOLE_COLUMNS * CHARWIDTH * (SCREEN_BPP / 8));
   dstrect.x = win.x + CONSOLE_LMARGIN * CHARWIDTH;
   dstrect.y = win.y + (CONSOLE_SHIFT + CONSOLE_LINES - 1) * LINEHEIGHT;
   dstrect.w = CONSOLE_COLUMNS * CHARWIDTH;
   dstrect.h = CHARHEIGHT;
   SDL_FillRect(screen, &dstrect, screen_color);
   change_alpha(&dstrect, background_alpha);
   SDL_UnlockSurface(screen);
   memcpy(console_buffer, console_buffer + CONSOLE_COLUMNS, CONSOLE_COLUMNS * (CONSOLE_LINES-1));
   memset(console_buffer + CONSOLE_COLUMNS * (CONSOLE_LINES-1), ' ', CONSOLE_COLUMNS);
}

void scroll_screen_down(int from_line)
{
   int line, scanline;
   SDL_Rect dstrect;
   if (!screen) return;
   SDL_LockSurface(screen);
   for (scanline = CONSOLE_LINES * LINEHEIGHT - 1; scanline >= LINEHEIGHT; scanline--)
       memcpy(screen->pixels + (win.y + scanline + CONSOLE_SHIFT * LINEHEIGHT) * screen->pitch + (win.x + CONSOLE_LMARGIN*CHARWIDTH) * (SCREEN_BPP/8),
       screen->pixels + (win.y + scanline - (CONSOLE_SHIFT-1) * LINEHEIGHT) * screen->pitch + (win.x + CONSOLE_LMARGIN*CHARWIDTH) * (SCREEN_BPP/8),
       CONSOLE_COLUMNS * CHARWIDTH * (SCREEN_BPP / 8));
   dstrect.x = win.x + CONSOLE_LMARGIN * CHARWIDTH;
   dstrect.y = win.y + (CONSOLE_SHIFT + from_line) * LINEHEIGHT;
   dstrect.w = CONSOLE_COLUMNS * CHARWIDTH;
   dstrect.h = CHARHEIGHT;
   SDL_FillRect(screen, &dstrect, screen_color);
   change_alpha(&dstrect, background_alpha);
   SDL_UnlockSurface(screen);
   for (line = CONSOLE_LINES-1; line > from_line+1; line--)
       memcpy(console_buffer + line * CONSOLE_COLUMNS, console_buffer + (line-1) * CONSOLE_COLUMNS, CONSOLE_COLUMNS);
   memset(console_buffer + from_line * CONSOLE_COLUMNS, ' ', CONSOLE_COLUMNS);
}

void hide_cursor()
{
   SDL_Rect dstrect;
   if (!screen) return;
   if (cursor_visible)
   {
      if (cur.x >= CONSOLE_COLUMNS) return;
      if (cur.y >= CONSOLE_SHIFT + CONSOLE_LINES) return;
      if (cur.y < CONSOLE_SHIFT) return;
      dstrect.x = win.x + (cur.x + CONSOLE_LMARGIN) * CHARWIDTH;
      dstrect.y = win.y + cur.y * LINEHEIGHT + CHARHEIGHT;
      dstrect.w = CURSORWIDTH;
      dstrect.h = CURSORHEIGHT;
      SDL_FillRect(screen, &dstrect, screen_color);
      change_alpha(&dstrect, background_alpha);
      cursor_visible = 0;
   }
}

void draw_cursor(int flip)
{
   int x, y, ln;
   char s[8];
   SDL_Rect dstrect;
   if (!screen) return;
   if (cursor_visible) return;
   if (cur.x >= CONSOLE_COLUMNS) return;
   if (cur.y >= CONSOLE_SHIFT + CONSOLE_LINES) return;
   dstrect.x = win.x + (cur.x + CONSOLE_LMARGIN) * CHARWIDTH;
   dstrect.y = win.y + cur.y * LINEHEIGHT + CHARHEIGHT;
   dstrect.w = CURSORWIDTH;
   dstrect.h = CURSORHEIGHT;
   SDL_FillRect(screen, &dstrect, cursor_color);
   cursor_visible = 1;
   sprintf(s, "{%02d,%02d}", cur.x+1, cur.y+1 - CONSOLE_SHIFT);
   ln = strlen(s);
   x = CONSOLE_COLUMNS - 8;
   y = CONSOLE_LINES + 2;
   console_textout(x, y, s, 0);
   dstrect.x = win.x + (x + CONSOLE_LMARGIN) * CHARWIDTH;
   dstrect.y = win.y + y * LINEHEIGHT;
   dstrect.w = ln * CHARWIDTH;
   dstrect.h = CHARHEIGHT;
   change_text_color_and_alpha(&dstrect, &curpos_color, background_alpha);
   if (flip) SDL_Flip(screen);
}

void new_line()
{
   if (cur.y < CONSOLE_SHIFT + CONSOLE_LINES - 1) cur.y++;
   else
   {
      scroll_screen_up();
      cur.y = CONSOLE_SHIFT + CONSOLE_LINES - 1;
   }
   cur.x = 0;
}

void console_char(char c, int flip)
{
   char s[2];
   if (c)
   {
      if (c == '\n') { new_line(); return; }
      s[0] = c;
      s[1] = 0;
      console_textout(cur.x, cur.y, s, flip);
      console_buffer[cur.x + (cur.y - CONSOLE_SHIFT) * CONSOLE_COLUMNS] = c;
      cur.x++; if (cur.x >= CONSOLE_COLUMNS) { cur.x = 0; cur.y++; }
      if (cur.y >= CONSOLE_SHIFT + CONSOLE_LINES)
      {
         scroll_screen_up();
         cur.y = CONSOLE_SHIFT + CONSOLE_LINES - 1;
      }
   }
}

void console_print(char *s)
{
   int ln, i;
   if (!screen) return;
   ln = strlen(s); if (ln < 1) return;
   for (i = 0; i < ln; i++) console_char(s[i], 0);
   SDL_Flip(screen);
}

void disconnect(int *sockfd)
{
   if (comm_thread_is_running) stop_comm_thread(sockfd);
   if (*sockfd != -1) close(*sockfd);
}

void clear_cbuffer()
{
   cbuf_len = 0;
   cbuf_write = 0;
   cbuf_read = 0;
}

void comm_thread(int *sockfd)
{
   comm_thread_is_running = 1;
   do
   {
     SDL_Delay(1);
     if ((buffer_len > 0) || (*sockfd == -1)) SDL_Delay(10);
     else
     if ((buffer_len += recv(*sockfd, buffer+buffer_len, MAXDATASIZE-buffer_len, 0)) == -1)
        abort_comm_thread = 1;
   } while (!abort_comm_thread);
   comm_thread_is_running = 0;
}

int put_bytes_to_cbuf(char *buf, int num)
{
   int i;
   if (num <= 0) return 0;
   if (num > MAX_CBUFLEN - cbuf_len) return 1;
   for (i=0; i<num; i++)
   {
       cbuf[cbuf_write++] = *(buf++);
       cbuf_len++;
       if (cbuf_write >= MAX_CBUFLEN) cbuf_write=0;
   }
   return 0;
}

int get_byte_from_cbuf(void)
{
   BYTE b;
   if (cbuf_len <= 0) return -1;
   if (cbuf_read >= MAX_CBUFLEN) cbuf_read = 0;
   b = cbuf[cbuf_read++];
   cbuf_len--;
   return b;
}

int get_prev_byte_from_cbuf(int back)
{
   BYTE b;
   int temp_read;
   if (back >= MAX_CBUFLEN) return -1;
   temp_read = cbuf_read - back;
   if (temp_read < 0) temp_read += MAX_CBUFLEN;
   b = cbuf[temp_read];
   return b;
}

int send_IAC(int *sockfd, BYTE operation_type, BYTE option)
{
   char command[3];
   command[0] = IAC;
   command[1] = operation_type;
   command[2] = option;
   return datasend(sockfd, command, 3);
}

int send_SB_TTYPE(int *sockfd)
{
   char command[sizeof(ttyp)+6];
   int z=0;
   command[z++] = IAC;
   command[z++] = SB;
   command[z++] = TELOPT_TTYPE;
   command[z++] = 0;
   strcpy(command+z, ttyp); z += strlen(ttyp);
   command[z++] = IAC;
   command[z++] = SE;
   return datasend(sockfd, command, z);
}

int send_SB_NAWS(int *sockfd)
{
   char command[9];
   int z=0;
   command[z++] = IAC;
   command[z++] = SB;
   command[z++] = TELOPT_NAWS;
   command[z++] = CONSOLE_COLUMNS >> 8;
   command[z++] = CONSOLE_COLUMNS & 0xFF;
   command[z++] = CONSOLE_LINES >> 8;
   command[z++] = CONSOLE_LINES & 0xFF;
   command[z++] = IAC;
   command[z++] = SE;
   return datasend(sockfd, command, z);
}

void backspace(int with_erase)
{
   cur.x--; if (cur.x < 0) { cur.x = CONSOLE_COLUMNS - 1; cur.y--; }
   if (cur.y < CONSOLE_SHIFT) cur.y = CONSOLE_SHIFT;
   if (with_erase)
   {
      console_textout(cur.x, cur.y, " ", 0);
      console_buffer[cur.x + (cur.y - CONSOLE_SHIFT) * CONSOLE_COLUMNS] = ' ';
   }
}

void reset_terminal()
{
   int i;
   cur.x = 0;
   cur.y = CONSOLE_SHIFT;
   ANSI_saved_cur = cur;
   for (i = 0; i < CONSOLE_COLUMNS; i++) tabstops[i] = 0;
}

void cls(int from_line, int before_line)
{
   int i;
   char empty_line[CONSOLE_COLUMNS+1];
   if (!screen) return;
   memset(empty_line, ' ', CONSOLE_COLUMNS);
   empty_line[CONSOLE_COLUMNS] = 0;
   for (i = from_line; i < before_line; i++)
       console_textout(0, i + CONSOLE_SHIFT, empty_line, 0);
   cur.x = 0;
   cur.y = CONSOLE_SHIFT;
   SDL_Flip(screen);
}

int extract_params(char *buf, int buflen)
{
   char c;
   int i = 0;
   int k = 0;
   int x = 1;
   if (buflen < 1) return 0;
   while (buflen && ((c = get_prev_byte_from_cbuf(x++)) != '[')) buflen--;
   if (buflen <= 0) return 0;
   x-=2;
   if (x < 1) return 0;
   for (i=x; i > 1; i--) buf[k++] = get_prev_byte_from_cbuf(i);
   buf[k] = 0;
   return k;
}

void cls_to_cur()
{
   int i;
   char empty_line[CONSOLE_COLUMNS+1];
   if (!screen) return;
   memset(empty_line, ' ', CONSOLE_COLUMNS);
   empty_line[CONSOLE_COLUMNS] = 0;
   if (cur.y > CONSOLE_SHIFT)
      for (i = 0; i < cur.y - CONSOLE_SHIFT-1; i++)
   console_textout(0, i + CONSOLE_SHIFT, empty_line, 0);
   empty_line[cur.x + 1] = 0;
   console_textout(0, cur.y, empty_line, 0);
   SDL_Flip(screen);
}

int parse(int *sockfd)
{
   int i, ib, ioption, count;
   BYTE operation_type;
   char opbuf[80];
   if (cbuf_len <= 0) return 0;
   if (*sockfd == -1) return 1;
   hide_cursor();
   while(cbuf_len)
   {
      ib = get_byte_from_cbuf();
      if (ib != -1)
      {
         switch(ib)
         {
            case IAC:
              if (cbuf_len >= 1)
              {
                 ib = get_byte_from_cbuf();
                 if (ib == -1) return 1; else operation_type = ib;
                 if (operation_type == SE) ioption=-1;
                 else
                 {
                    if (cbuf_len >= 1)
                    {
                       ib = get_byte_from_cbuf();
                       if (ib == -1) return 1; else ioption = ib;
                    }
                    else ioption = -1;
                 }
                 switch(operation_type)
                 {
                    case DO:
                      switch(ioption)
                      {
                        case TELOPT_TTYPE:
                             if (send_IAC(sockfd, WILL, ioption)) return 1;
                             break;
                        case TELOPT_NAWS:
                             if (send_IAC(sockfd, WILL, ioption)) return 1;
                             if (send_SB_NAWS(sockfd)) return 1;
                             break;
                        default:
                             if (send_IAC(sockfd, WONT, ioption)) return 1;
                             break;
                      }
                      break;
                    case SB:
                      switch(ioption)
                      {
                        case TELOPT_TTYPE:
                             if (cbuf_len>=3)
                             {
                                ib = get_byte_from_cbuf();
                                if (ib != 1) return 1;
                                ib = get_byte_from_cbuf();
                                if (ib != IAC) return 1;
                                ib = get_byte_from_cbuf();
                                if (ib != SE) return 1;
                             }
                             if (send_SB_TTYPE(sockfd)) return 1;
                             break;
                        default:
                          if (send_IAC(sockfd, WONT, ioption)) return 1;
                      }
                      break;
                    case SE:
                      break;
                    default:
                      if (send_IAC(sockfd, WONT, ioption)) return 1;
                 }
              }
              else return 1;
              break;
            case LF:
              if (get_prev_byte_from_cbuf(3)==15) break;
              new_line();
              break;
            case CR:
              cur.x=0;
              break;
            case BELL:
              break;
            case BACKSPC:
              backspace(0);
              break;
	     case 15:
	  break;
	     case 133:
	     case 136:
	  tabstops[cur.x] = 1;
	  break;
            case 242:
              break;
            case ESC:
              if (cbuf_len>=1)
              {
                 ib = get_byte_from_cbuf();
                 switch(ib)
                 {
		     case 'D':
		   i = cur.x;
		   new_line();
		   cur.x = i;
		   break;
		     case 'E':
		   new_line();
		   break;
		     case 'H':
		   tabstops[cur.x] = 1;
		   break;
		     case 'M':
		   if (cur.y == CONSOLE_SHIFT) scroll_screen_down(0);
		   else cur.y--;
		   break;
		     case 'c':
		   reset_terminal();
		   cls(0, CONSOLE_LINES);
		   break;
		     case '7':
		   ANSI_saved_cur = cur;
		   break;
		     case '8':
		   cur = ANSI_saved_cur;
		   break;
                   case '[':
                        while(cbuf_len)
                        {
                          ib = get_byte_from_cbuf();
                          if (ib == -1) return 1;
                          if ((ib >= 64) && (ib <= 126))
                          {
                             switch(ib)
                             {
				    case '@':
					 count = 1;
					 if (extract_params(opbuf, sizeof(opbuf)))
					 {
						sscanf(opbuf, "%d", &count);
					 }
					 if (count + cur.x >= CONSOLE_COLUMNS) count = CONSOLE_COLUMNS - cur.x;
					 if (count > 0)
					 {
					     for (i=cur.x; i < cur.x + count; i++) console_textout(i, cur.y, " ", 0);
					     if (screen) SDL_Flip(screen);
					 }
					 break;
				    case 'A':
					 count = 1;
					 if (extract_params(opbuf, sizeof(opbuf)))
					 {
						sscanf(opbuf, "%d", &count);
					 }
					 cur.y -= count; if (cur.y < CONSOLE_SHIFT) cur.y = CONSOLE_SHIFT;
					 break;
				    case 'B':
					 count = 1;
					 if (extract_params(opbuf, sizeof(opbuf)))
					 {
						sscanf(opbuf, "%d", &count);
					 }
					 cur.y += count; if (cur.y > CONSOLE_SHIFT+CONSOLE_LINES-1) cur.y = CONSOLE_SHIFT+CONSOLE_LINES-1;
					 break;
				    case 'C':
					 count = 1;
					 if (extract_params(opbuf, sizeof(opbuf)))
					 {
						sscanf(opbuf, "%d", &count);
					 }
					 cur.x += count; if (cur.x >= CONSOLE_COLUMNS) cur.x = CONSOLE_COLUMNS-1;
					 break;
				    case 'D':
					 count = 1;
					 if (extract_params(opbuf, sizeof(opbuf)))
					 {
						sscanf(opbuf, "%d", &count);
					 }
					 cur.x -= count; if (cur.x < 0) cur.x = 0;
					 break;
				    case 'E':
					 count = 1;
					 if (extract_params(opbuf, sizeof(opbuf)))
					 {
						sscanf(opbuf, "%d", &count);
					 }
					 cur.x = 0;
					 cur.y += count; if (cur.y >= CONSOLE_LINES + CONSOLE_SHIFT) cur.y = CONSOLE_SHIFT + CONSOLE_LINES - 1;
					 break;
				    case 'F':
					 count = 1;
					 if (extract_params(opbuf, sizeof(opbuf)))
					 {
						sscanf(opbuf, "%d", &count);
					 }
					 cur.x = 0;
					 cur.y -= count; if (cur.y < CONSOLE_SHIFT) cur.y = CONSOLE_SHIFT;
					 break;
				    case 'G':
					 count = 1;
					 if (extract_params(opbuf, sizeof(opbuf)))
					 {
						sscanf(opbuf, "%d", &count);
					 }
					 count--;
					 if ((count >= 0) && (count < CONSOLE_COLUMNS)) cur.x = count;
					 break;
                                    case 'H':
		                         if ((get_prev_byte_from_cbuf(3) == ESC) && (get_prev_byte_from_cbuf(2) == '['))
		                         {
		                             cls(0, CONSOLE_LINES);
		                         }
		                         else
		                         {
						if (extract_params(opbuf, sizeof(opbuf)))
						{
							sscanf(opbuf, "%d;%d", &cur.y, &cur.x);
							cur.x--;
							cur.y += CONSOLE_SHIFT - 1;
						}
		                         }
                                         break;
				    case 'I':
					 count = 1;
					 if (extract_params(opbuf, sizeof(opbuf)))
					 {
						sscanf(opbuf, "%d", &count);
					 }
					 if ((count > 0) && (cur.x+1 < CONSOLE_COLUMNS))
				     for (i = cur.x+1; ((i < CONSOLE_COLUMNS) && (count > 0)); i++)
					 if (tabstops[i]) { cur.x = i; count--; }
					 break;
				    case 'J':
					 count = 0;
					 if (extract_params(opbuf, sizeof(opbuf)))
					 {
						sscanf(opbuf, "%d", &count);
					 }
					 if (count == 2) cls(0, CONSOLE_LINES);
					 else if (count == 1) cls_to_cur();
					 else
					 {
					     tmp_cur = cur;
					     for (i = cur.x; i < CONSOLE_COLUMNS; i++) console_textout(i, cur.y, " ", 0);
					     if (screen) SDL_Flip(screen);
					     if (cur.y < CONSOLE_LINES-1) cls(cur.y - CONSOLE_SHIFT, CONSOLE_LINES);
					     cur = tmp_cur;
					 }
                                     break;
				    case 'K':
					 count = 0;
					 if (extract_params(opbuf, sizeof(opbuf)))
					 {
						sscanf(opbuf, "%d", &count);
					 }
					 if (count == 1)
					 {
				     for (i = 0; i <= cur.x; i++) console_textout(i, cur.y, " ", 0);
				     if (screen) SDL_Flip(screen);
					 }
					 else
					 if (count == 2)
					 {
					     for (i = 0; i < CONSOLE_COLUMNS; i++) console_textout(i, cur.y, " ", 0);
					     if (screen) SDL_Flip(screen);
					 }
					 else
					 if (count == 0)
					 {
					     for (i = cur.x; i < CONSOLE_COLUMNS; i++) console_textout(i, cur.y, " ", 0);
					     if (screen) SDL_Flip(screen);
					 }
					 break;
				    case 'L':
					 count = 1;
					 if (extract_params(opbuf, sizeof(opbuf)))
					 {
						sscanf(opbuf, "%d", &count);
					 }
					 while (count--) scroll_screen_down(cur.y - CONSOLE_SHIFT);
					 break;
				    case 'M':
					 count = 1;
					 if (extract_params(opbuf, sizeof(opbuf)))
					 {
						sscanf(opbuf, "%d", &count);
					 }
					 if (cur.y - CONSOLE_SHIFT + count > CONSOLE_LINES) count = CONSOLE_LINES - (cur.y - CONSOLE_SHIFT);
					 if (count > 0) cls(cur.y - CONSOLE_SHIFT, count);
					 break;
				    case 'P':
					 count = 1;
					 if (extract_params(opbuf, sizeof(opbuf)))
					 {
						sscanf(opbuf, "%d", &count);
					 }
					 if (count > cur.x) count = cur.x;
					 if (count > 0)
					 {
					     i = cur.x;
					     while ((count--) && (i-- >= 0)) console_textout(i, cur.y, " ", 0);
					     if (screen) SDL_Flip(screen);
					 }
					 break;
				    case 'X':
					 count = 1;
					 if (extract_params(opbuf, sizeof(opbuf)))
					 {
						sscanf(opbuf, "%d", &count);
					 }
					 if (count>0)
					 {
					     ib = cur.x;
					     while ((count--) && (ib < CONSOLE_COLUMNS)) console_textout(ib++, cur.y, " ", 0);
					 }
					 break;
				    case 'Z':
					 count = 1;
					 if (extract_params(opbuf, sizeof(opbuf)))
					 {
						sscanf(opbuf, "%d", &count);
					 }
					 if ((count > 0) && (cur.x > 0))
				  	   for (i = cur.x-1; ((i >= 0) && (count > 0)); i++)
					 if (tabstops[i]) { cur.x = i; count--; }
					 break;
				    case 'd':
					 count = 1;
					 if (extract_params(opbuf, sizeof(opbuf)))
					 {
						sscanf(opbuf, "%d", &count);
					 }
					 count--;
					 if ((count > 0) && (count < CONSOLE_LINES)) cur.y = count + CONSOLE_SHIFT;
					 break;
				    case 'f':
					 if (extract_params(opbuf, sizeof(opbuf)))
					 {
					     sscanf(opbuf, "%d,%d", &cur.y, &cur.x);
					     cur.x--;
					     cur.y += CONSOLE_SHIFT - 1;
					 }
					 break;
				    case 'g':
					 count = 0;
					 if (extract_params(opbuf, sizeof(opbuf)))
					 {
						sscanf(opbuf, "%d", &count);
					 }
					 if (count == 0)
					 {
				     		tabstops[cur.x] = 0;
					 }
					 else if (count == 3)
					 {
				   		for (i=0; i < CONSOLE_COLUMNS; i++) tabstops[i] = 0;
					 }
					 break;
				    case 'm':
					 break;
				    case 'n':
					 break;
				    case 'p':
					 if (get_prev_byte_from_cbuf(2) == '!') reset_terminal();
					 break;
				    case 'r':
					 break;
				    case 's':
					 ANSI_saved_cur = cur;
					 break;
				    case 'u':
					 cur = ANSI_saved_cur;
					 break;
				    case '0':
					 break;
		                        default:
		                        break;
                             }
                             ib = 0;
                             break;
                          }
                        }
                        break;
                   default:
                        ib = 0;
                        break;
                 }
              }
            default:
              if (ib >= 32) console_char((char)ib, 0);
         }
      }
   }
   draw_cursor(1);
   return 0;
}

int start_comm_thread(int *sockfd)
{
  int timeout;
  abort_comm_thread = 0;
  comm_thread_is_running = 0;
  if (pthread_create(&ID_comm_thread, NULL , (void *)comm_thread, sockfd ) != 0)
     return 0;
  timeout=100;
  do SDL_Delay(DELAY_THREAD); while (!comm_thread_is_running && (--timeout>0));
  if (timeout==0) return 0;
  return 1;
}

void display_IPs_now()
{
   int x, y, ln;
   SDL_Rect dstrect;
   ln = strlen(IPs_now);
   x = CONSOLE_COLUMNS-2 - ln;
   y = 1;
   console_textout(x, y, IPs_now, 0);
   dstrect.x = win.x + (x + CONSOLE_LMARGIN) * CHARWIDTH;
   dstrect.y = win.y + y * LINEHEIGHT;
   dstrect.w = ln * CHARWIDTH;
   dstrect.h = CHARHEIGHT;
   change_text_color_and_alpha(&dstrect, &IPs_color, background_alpha);
}

int reconnect(int *sockfd, int re)
{
   struct hostent *he;
   struct sockaddr_in their_addr;
   Uint32 IPaddr;
   char s[6];
   if (*sockfd != -1) disconnect(sockfd);
   *sockfd = -1;
   IPs_now[0] = 0;
   char *pn = strstr(host, ":");
   if (!pn) pn = strstr(host, " ");
   if (pn)
   {
      port = atoi(pn+1);
      *pn = 0;
   }
   if (re)
   {
      new_line();
      new_line();
   }
   console_print(" * connecting to ");
   console_print(host);
   if (port != DEFAULT_PORT) { sprintf(s, ":%d", port); console_print(s); }
   console_print("...\n");
   buffer_len = 0;
   if ((he = gethostbyname(host)) == NULL) return 1;
   if ((*sockfd = socket(AF_INET, SOCK_STREAM, 0)) == -1) return 2;
   their_addr.sin_family = AF_INET;
   their_addr.sin_port = htons(port);
   their_addr.sin_addr = *((struct in_addr *)he->h_addr);
   memset(&(their_addr.sin_zero), '\0', 8);
   if (connect(*sockfd, (struct sockaddr *)&their_addr, sizeof(struct sockaddr)) == -1) return 3;
   IPaddr = *(Uint32*)he->h_addr_list[0];
   sprintf(IPs_now, "%d.%d.%d.%d", IPaddr & 0xFF, (IPaddr>>8) & 0xFF, (IPaddr>>16) & 0xFF, (IPaddr>>24) & 0xFF);
   display_IPs_now();
   strcpy(ttyp, DEF_TTYP);
   clear_cbuffer();
   if (!start_comm_thread(sockfd)) return 4;
   return 0;
}

void error_connect(int err)
{
   console_print("\n\nERROR! Cannot connect to ");
   console_print(host);
   console_print(" !\n");
   switch(err)
   {
      case 1: console_print("Cannot get host info! URL cannot be resolved!\n"); break;
      case 2: console_print("Cannot create socket!\n"); break;
      case 3: console_print("Host is not responding!\n"); break;
      case 4: console_print("Cannot start communication thread!\n"); break;
      default: ;
   }
   SDL_Delay(2000);
}

void draw_background()
{
   int frame_alpha;
   SDL_Rect dstrect;
   if (!screen) return;
   dstrect.x = win.x;
   dstrect.y = win.y;
   dstrect.w = CHARWIDTH * (CONSOLE_LMARGIN + CONSOLE_COLUMNS + CONSOLE_RMARGIN);
   dstrect.h = LINEHEIGHT * (CONSOLE_SHIFT + CONSOLE_LINES + BOTTOM_LINES);
   SDL_FillRect(screen, &dstrect, screen_color);
   change_alpha(&dstrect, background_alpha);
   frame_alpha = background_alpha *75/100;
   dstrect.h = CHARHEIGHT / 4;
   change_alpha(&dstrect, frame_alpha);
   dstrect.y += LINEHEIGHT * (CONSOLE_SHIFT + CONSOLE_LINES + BOTTOM_LINES) - dstrect.h;
   change_alpha(&dstrect, frame_alpha);
   dstrect.w = dstrect.h;
   dstrect.h = LINEHEIGHT * (CONSOLE_SHIFT + CONSOLE_LINES + BOTTOM_LINES);
   dstrect.x = win.x;
   dstrect.y = win.y;
   change_alpha(&dstrect, frame_alpha);
   dstrect.x += CHARWIDTH * (CONSOLE_LMARGIN + CONSOLE_COLUMNS + CONSOLE_RMARGIN) - dstrect.w;
   change_alpha(&dstrect, frame_alpha);
}

void erase_console()
{
   SDL_Rect dstrect;
   if (!screen) return;
   dstrect.x = win.x;
   dstrect.y = win.y;
   dstrect.w = CHARWIDTH * (CONSOLE_LMARGIN + CONSOLE_COLUMNS + CONSOLE_RMARGIN);
   dstrect.h = LINEHEIGHT * (CONSOLE_SHIFT + CONSOLE_LINES + BOTTOM_LINES);
   change_alpha(&dstrect, 0);
}

void refresh_console_window()
{
   int i, col, line;
   char s[2];
   hide_cursor();
   draw_background();
   s[1] = 0;
   i = 0;
   for (line = CONSOLE_SHIFT; line < (CONSOLE_SHIFT + CONSOLE_LINES); line++)
       for (col = 0; col < CONSOLE_COLUMNS; col++)
       {
           s[0] = console_buffer[i++];
    console_textout(col, line, s, 0);
       }
   display_IPs_now();
   draw_cursor(1);
}

void alpha_down()
{
   background_alpha -= ALPHA_STEP;
   if (background_alpha < 0) background_alpha = 0;
   refresh_console_window();
}

void alpha_up()
{
   background_alpha += ALPHA_STEP;
   if (background_alpha > 255) background_alpha = 255;
   refresh_console_window();
}

void move_window(int direction)
{
   erase_console();
   switch(direction)
   {
      case MOVE_LEFT:
    win.x -= MOVE_STEP;
    if (win.x < 0) win.x = 0;
    break;
      case MOVE_RIGHT:
    win.x += MOVE_STEP;
    if (win.x > MAX_WIN_X) win.x = MAX_WIN_X;
    break;
      case MOVE_UP:
    win.y -= MOVE_STEP;
    if (win.y < 0) win.y = 0;
    break;
      case MOVE_DOWN:
    win.y += MOVE_STEP;
    if (win.y > MAX_WIN_Y) win.y = MAX_WIN_Y;
    break;
      default: ;
   }
   refresh_console_window();
}

void show_help()
{
   new_line();
   new_line();
   console_print(APP_NAME); console_print(" HELP:\n");
   console_print("- F1: help\n");
   console_print("- F2: connect to another server\n");
   console_print("- F8 or F10: exit\n");
   console_print("- F12: clear screen\n");
   console_print("- Left ALT + ARROWS: move window\n");
   console_print("- Left ALT + [-]: increase transparency\n");
   console_print("- Left ALT + [+]: decrease transparency\n");
   console_print("- REMOTE CONTROL: PLAY=show console, STOP=hide console\n");
}

void change_address()
{
   hide_cursor();
   console_print("\n\nEnter new address: ");
   draw_cursor(1);
   entering_adr = 1;
   hostlen = 0;
}

void input_thread(int *sockfd)
{
   int i, scancode, key, ret, evtype;
   int shift, control, lalt, capslock, numlock;
   char ch;
   char autorepeat = 0;
   char autorepeat_stage = 0;
   shift = 0;
   control = 0;
   lalt = 0;
   capslock = 0;
   numlock = 0;
   input_thread_is_running = 1;
   do
   {
     ch = 0;
     SDL_Delay(1);
     if (buffer_len > 0)
     {
	int buf_len = buffer_len;
        if (put_bytes_to_cbuf(buffer, buf_len)) printf("c-buffer overflow error!\n");
        else parse(sockfd);
        buffer_len -= buf_len;
     }
     if (kbqueue_len > 0)
     {
	 int timeout=100;
	 while (kbqueue_lock > 0 && timeout--) SDL_Delay(10);
	 kbqueue_lock++;
	 scancode = kbqueue[kbqueue_tail++];
	 if (kbqueue_tail >= KB_QUEUE_SIZE) kbqueue_tail = 0;
	 kbqueue_len--;
	 kbqueue_lock--;
	 key = scancode & 0x00FF;
	 evtype = scancode & 0xFF00;

  switch (evtype)
  {
           case KEYSTATE_DOWN:
           case KEYSTATE_HOLD:
	   ch = 0;
	   if ((key == SYMK_LSHIFT) || (key == SYMK_RSHIFT)) shift = 1;
	   if ((key == SYMK_LCTRL) || (key == SYMK_RCTRL)) control = 1;
	   if ( key == SYMK_LALT) lalt = 1;
	   if (numlock == 0) switch (key)
	   {
	     case SYMK_KP_1: key = SYMK_END; break;
	     case SYMK_KP_2: key = SYMK_DOWN; break;
	     case SYMK_KP_3: key = SYMK_PGUP; break;
	     case SYMK_KP_4: key = SYMK_LEFT; break;
	     case SYMK_KP_6: key = SYMK_RIGHT; break;
	     case SYMK_KP_7: key = SYMK_HOME; break;
	     case SYMK_KP_8: key = SYMK_UP; break;
	     case SYMK_KP_9: key = SYMK_PGUP; break;
	     case SYMK_KP_0: key = SYMK_INSERT; break;
	     case SYMK_KP_PERIOD: key = SYMK_DELETE; break;
	     default: ;
	   }
           if (control) switch (key)
           	{
                   case SYMK_c:
                        ch = 3;
			break;
                   case SYMK_z:
                        ch = 26;
                        break;
                   default:
                        break;
                }
                else switch (key)
                {
     case SYMK_CAPSLOCK:
	   if ((scancode & 0xFF00) == KEYSTATE_DOWN) { if (capslock) capslock=0; else capslock=1; }
	   break;
     case SYMK_NUMLOCK:
	   if ((scancode & 0xFF00) == KEYSTATE_DOWN) { if (numlock) numlock=0; else numlock=1; }
	   break;
     case SYMK_BACKSPACE:
	   ch = BACKSPC;
	   break;
     case SYMK_TAB:
	   if (entering_adr) break;
	   if (cur.x < CONSOLE_COLUMNS)
	   {
	       for (i = cur.x; i < CONSOLE_COLUMNS; i++)
	    if (tabstops[i])
	    {
	       while (i--) console_textout(cur.x++, cur.y, " ", 0);
	       if (screen) SDL_Flip(screen);
	       i = CONSOLE_COLUMNS;
	    }
	   }
	   else ch = ' ';
	   break;
     case SYMK_RETURN:
     case SYMK_KP_ENTER:
	   if (entering_adr)
	   {
	      entering_adr = 0;
	      hide_cursor();
	      ret = reconnect(sockfd, 1);
	      if (ret)
	      {
		 error_connect(ret);
		 draw_cursor(1);
		 change_address();
	      }
	      ch = 0;
	      autorepeat = 0;
	      autorepeat_stage = 0;
	   }
	   else ch = CR;
	   break;
     case SYMK_ESCAPE:
	   ch = 27;
	   break;
     case SYMK_DELETE:
	   break;
     case SYMK_SPACE: ch = ' '; break;
     case SYMK_BACKQUOTE: ch = shift?'~':'`'; break;
     case SYMK_1: ch = shift?'!':'1'; break;
     case SYMK_2: ch = shift?'@':'2'; break;
     case SYMK_3: ch = shift?'#':'3'; break;
     case SYMK_4: ch = shift?'$':'4'; break;
     case SYMK_5: ch = shift?'%':'5'; break;
     case SYMK_6: ch = shift?'^':'6'; break;
     case SYMK_7: ch = shift?'&':'7'; break;
     case SYMK_8: ch = shift?'*':'8'; break;
     case SYMK_9: ch = shift?'(':'9'; break;
     case SYMK_0: ch = shift?')':'0'; break;
     case SYMK_KP_1: ch = '1'; break;
     case SYMK_KP_2: ch = '2'; break;
     case SYMK_KP_3: ch = '3'; break;
     case SYMK_KP_4: ch = '4'; break;
     case SYMK_KP_5: ch = '5'; break;
     case SYMK_KP_6: ch = '6'; break;
     case SYMK_KP_7: ch = '7'; break;
     case SYMK_KP_8: ch = '8'; break;
     case SYMK_KP_9: ch = '9'; break;
     case SYMK_KP_0: ch = '0'; break;
     case SYMK_a: ch = (shift^capslock)?'A':'a'; break;
     case SYMK_b: ch = (shift^capslock)?'B':'b'; break;
     case SYMK_c: ch = (shift^capslock)?'C':'c'; break;
     case SYMK_d: ch = (shift^capslock)?'D':'d'; break;
     case SYMK_e: ch = (shift^capslock)?'E':'e'; break;
     case SYMK_f: ch = (shift^capslock)?'F':'f'; break;
     case SYMK_g: ch = (shift^capslock)?'G':'g'; break;
     case SYMK_h: ch = (shift^capslock)?'H':'h'; break;
     case SYMK_i: ch = (shift^capslock)?'I':'i'; break;
     case SYMK_j: ch = (shift^capslock)?'J':'j'; break;
     case SYMK_k: ch = (shift^capslock)?'K':'k'; break;
     case SYMK_l: ch = (shift^capslock)?'L':'l'; break;
     case SYMK_m: ch = (shift^capslock)?'M':'m'; break;
     case SYMK_n: ch = (shift^capslock)?'N':'n'; break;
     case SYMK_o: ch = (shift^capslock)?'O':'o'; break;
     case SYMK_p: ch = (shift^capslock)?'P':'p'; break;
     case SYMK_q: ch = (shift^capslock)?'Q':'q'; break;
     case SYMK_r: ch = (shift^capslock)?'R':'r'; break;
     case SYMK_s: ch = (shift^capslock)?'S':'s'; break;
     case SYMK_t: ch = (shift^capslock)?'T':'t'; break;
     case SYMK_u: ch = (shift^capslock)?'U':'u'; break;
     case SYMK_v: ch = (shift^capslock)?'V':'v'; break;
     case SYMK_w: ch = (shift^capslock)?'W':'w'; break;
     case SYMK_x: ch = (shift^capslock)?'X':'x'; break;
     case SYMK_y: ch = (shift^capslock)?'Y':'y'; break;
     case SYMK_z: ch = (shift^capslock)?'Z':'z'; break;

     case SYMK_MINUS: ch = shift?'_':'-'; break;
     case SYMK_EQUALS: ch = shift?'+':'='; break;
     case SYMK_BACKSLASH: ch = shift?'|':'\\'; break;
     case SYMK_LEFTBRACKET: ch = shift?'{':'['; break;
     case SYMK_RIGHTBRACKET: ch = shift?'}':']'; break;
     case SYMK_SEMICOLON: ch = shift?':':';'; break;
     case SYMK_APOSTROPH: ch = shift?'\'':'"'; break;
     case SYMK_COMMA: ch = shift?'<':','; break;
     case SYMK_PERIOD: ch = shift?'>':'.'; break;
     case SYMK_SLASH: ch = shift?'?':'/'; break;

     case SYMK_KP_DIVIDE: ch = '/'; break;
     case SYMK_KP_MULTIPLY: ch = '*'; break;
     case SYMK_KP_MINUS: if (lalt) alpha_down(); else ch = '-'; break;
     case SYMK_KP_PLUS: if (lalt) alpha_up(); else ch = '+'; break;
     case SYMK_KP_PERIOD: ch = '.'; break;

     case SYMK_F1:
	   if (entering_adr) break;
	   hide_cursor();
                       show_help();
   draw_cursor(0);
   ch = CR;
                        break;
     case SYMK_F2:
   if (entering_adr) break;
   change_address();
   break;
                   case SYMK_F8:
                   case SYMK_F10:
   abort_input_thread = 1;
   abort_keyboard_thread = 1;
   if (*sockfd != -1) disconnect(sockfd);
                        break;
                   case SYMK_F12:
   if (entering_adr) break;
                        hide_cursor();
                        cls(0, CONSOLE_LINES);
                        draw_cursor(0);
                        if (screen) SDL_Flip(screen);
                        break;
     case SYMK_LEFT:
   if (lalt) { move_window(MOVE_LEFT); break; }
   special = 1;
   ch = 'D';
   break;
     case SYMK_RIGHT:
   if (lalt) { move_window(MOVE_RIGHT); break; }
   special = 1;
   ch = 'C';
   break;
     case SYMK_UP:
   if (lalt) { move_window(MOVE_UP); break; }
   if (entering_adr) break;
   special = 1;
   ch = 'A';
   break;
     case SYMK_DOWN:
   if (lalt) { move_window(MOVE_DOWN); break; }
   if (entering_adr) break;
   special = 1;
   ch = 'B';
   break;
                   default:
                        break;
                }
                break;
           case KEYSTATE_UP:
  autorepeat = 0;
  special = 0;
  if ((key == SYMK_LSHIFT) || (key == SYMK_RSHIFT)) shift = 0;
  if ((key == SYMK_LCTRL) || (key == SYMK_RCTRL)) control = 0;
  if ( key == SYMK_LALT) lalt = 0;
                break;
           default:
                break;
        }
        if (ch) { autorepeat = ch; autorepeat_stage = 1; }
     }
     if (special && entering_adr) { special=0; autorepeat=0; }
     if (autorepeat)
     {
        int send_now = 0;
        if (autorepeat_stage == 1) { send_now = 1; autorepeat_stage++; }
	 else
        {
	    if (autorepeat_stage >= AUTOREPEAT_STAGES ) { SDL_Delay(AUTOREPEAT_DELAY); send_now = 1; }
           else { SDL_Delay(AUTOREPEAT_HOLD); autorepeat_stage++; }
        }
        if (send_now)
        {
           if (entering_adr)
	   {
	       if (autorepeat == BACKSPC)
	       {
		  if ((entering_adr) && (hostlen > 0))
		  {
		     hide_cursor();
		     backspace(1);
		     draw_cursor(1);
		     host[--hostlen]=0;
		  }
	       }
	       else if (hostlen < MAX_HOSTLEN)
	       {
		   host[hostlen++] = autorepeat; host[hostlen] = 0;
		   hide_cursor(); console_char(autorepeat, 0); draw_cursor(1);
	       }
   	  }
          else
    	  {
	       if (special) { datasend(sockfd, ESCSEQ, 2); }
	       datasend(sockfd, &autorepeat, 1);
	  }
        }
     }
   } while (!abort_input_thread);

   input_thread_is_running = 0;
   if (fonts) { SDL_FreeSurface(fonts); fonts=NULL; }
   if (SDL_was_init) SDL_Quit();
   SDL_was_init = 0;
   screen = NULL;
   is_console_window = 0;
   if (chdir(old_path) == -1) ;
   setenv("HOME", old_path, 1);
}

void keyboard_thread(int *sockfd)
{
   FILE *queue_file;
   int key;
   keyboard_thread_is_running = 1;
   queue_file = fopen(EVENT_QUEUE_FILE, "rb");
   if (queue_file)
   {
      while (!abort_keyboard_thread)
      {
   if (kbqueue_len >= KB_QUEUE_SIZE) { SDL_Delay(1); continue; }
   key = get_kbscancode(queue_file);
   int timeout=100;
   while (kbqueue_lock > 0 && timeout--) SDL_Delay(10);
   kbqueue_lock++;
   if (kbqueue_len < KB_QUEUE_SIZE)
   {
      kbqueue[kbqueue_head++] = key;
      if (kbqueue_head >= KB_QUEUE_SIZE) kbqueue_head = 0;
      kbqueue_len++;
   }
   kbqueue_lock--;
      }
      fclose(queue_file);
   }
   keyboard_thread_is_running = 0;
}

int start_input_thread(int *sockfd)
{
  int timeout;
  abort_input_thread = 0;
  input_thread_is_running = 0;
  if (pthread_create(&ID_input_thread, NULL , (void *)input_thread, sockfd ) != 0)
     return 0;
  timeout=100;
  do SDL_Delay(DELAY_THREAD); while (!input_thread_is_running && (--timeout>0));
  if (timeout==0) return 0;
  return 1;
}

int start_keyboard_thread(int *sockfd)
{
  int timeout;
  kbqueue_head = 0;
  kbqueue_tail = 0;
  kbqueue_len = 0;
  kbqueue_lock = 0;
  if (keyboard_thread_is_running) return 1;
  abort_keyboard_thread = 0;
  keyboard_thread_is_running = 0;
  if (pthread_create(&ID_keyboard_thread, NULL , (void *)keyboard_thread, sockfd ) != 0)
     return 0;
  timeout=100;
  do SDL_Delay(DELAY_THREAD); while (!keyboard_thread_is_running && (--timeout>0));
  if (timeout==0) return 0;
  return 1;
}

int show_console()
{
   char s[MAX_PATH];
   if (is_console_window) { refresh_console_window(); return KEY_NOTHING; }
   if (getcwd(old_path, sizeof(old_path)) == NULL) strcpy(old_path, "/mtd_exe/");
   if (chdir(path) == -1) ;
   setenv("HOME", path, 1);
   SDL_was_init = 0;
   if (SDL_Init(SDL_INIT_VIDEO) < 0) return KEY_DISP_CABLE;
   SDL_was_init = 1;
   screen = SDL_SetVideoMode(SCREEN_W, SCREEN_H, SCREEN_BPP, SCREEN_FLAGS);
   if (!screen) return KEY_DISP_CABLE;
   videoinfo = (SDL_VideoInfo *)SDL_GetVideoInfo();
   cursor_color = SDL_MapRGB(videoinfo->vfmt, 255,255,255);
   screen_color = SDL_MapRGB(videoinfo->vfmt, 0, 0, 0);
   IPs_color = SDL_MapRGB(videoinfo->vfmt, 255,255, 0);
   curpos_color = SDL_MapRGB(videoinfo->vfmt, 128, 32, 32);
   sprintf(s, "%s/%s", path, FONTBITMAP);
   fonts = IMG_Load(s);
   if (fonts == NULL) return KEY_DISP_CABLE;
   fontrect.h = CHARHEIGHT;
   fontrect.w = CHARWIDTH;
   is_console_window = 1;
   cursor_visible = 0;
   entering_adr = 0;
   special = 0;
   sockfd = -1;
   cur.x = 0;
   cur.y = 0;
   if (keyboard_thread_is_running == 0)
   {
      background_alpha = DEFAULT_ALPHA;
      win.x = MAX_WIN_X / 2;
      win.y = MAX_WIN_Y / 2;
   }
   draw_background();
   memset(console_buffer, ' ', CONSOLE_COLUMNS * CONSOLE_LINES);
   reset_terminal();
   sprintf(s, " Welcome to %s %s (c)%d by %s\n\n", APP_NAME, APP_VER, APP_YEAR, APP_AUTHOR);
   console_print(s);
   if (!is_telnetd())
   {
      console_print(" * initializing telnet daemon...\n");
      if (run_telnetd()) return KEY_DISP_CABLE;
      if (!is_telnetd()) return KEY_DISP_CABLE;
   }
   if (!is_usbhid())
   {
      console_print(" * loading USB HID driver...\n");
      if (load_usbhid()) return KEY_DISP_CABLE;
      if (!is_usbhid()) return KEY_DISP_CABLE;
   }
   strcpy(host, DEFAULT_HOST);
   hostlen = strlen(host);
   port = DEFAULT_PORT;
   int ret = reconnect(&sockfd, 0);
   if (ret)
   {
      error_connect(ret);
      return KEY_DISP_CABLE;
   }
   SDL_EnableUNICODE(1);
   if (!start_keyboard_thread(&sockfd))
   {
      console_print("\nERROR! Cannot start keyboard thread! Check if USB keyboard is connected.\n");
      SDL_Delay(3000);
      stop_comm_thread(&sockfd);
      if (sockfd != -1) close(sockfd);
      sockfd = -1;
      return KEY_DISP_CABLE;
   }
   if (!start_input_thread(&sockfd))
   {
      console_print("\nINTERNAL ERROR! Cannot start input thread!\n");
      SDL_Delay(2000);
      stop_comm_thread(&sockfd);
      if (sockfd != -1) close(sockfd);
      sockfd = -1;
      return KEY_DISP_CABLE;
   }
   return KEY_NOTHING;
}

int hide_console()
{
   if (!is_console_window) return KEY_NOTHING;
   if (input_thread_is_running) stop_input_thread(&sockfd);
   if (comm_thread_is_running) stop_comm_thread(&sockfd);
   if (sockfd != -1) close(sockfd);
   sockfd = -1;
   if (fonts) { SDL_FreeSurface(fonts); fonts=NULL; }
   if (SDL_was_init) SDL_Quit();
   SDL_was_init = 0;
   screen = NULL;
   is_console_window = 0;
   if (chdir(old_path) == -1) ;
   setenv("HOME", old_path, 1);
   return KEY_NOTHING;
}

static int button_pressed(int key) __attribute__ ((noinline));
static int button_pressed(int key)
{
  switch (key)
  {
    case KEY_PLAY:
      key = show_console();
      if (key == KEY_DISP_CABLE) { key = KEY_NOTHING; hide_console(); }
      break;
    case KEY_STOP:
      key = hide_console();
      break;
    default:;
  }
  return(key);
}

void injection_press(int a, int button_code, int arg_r2) __attribute__ ((noinline));
void injection_press(int a, int button_code, int arg_r2)
{
 asm volatile(
  "STMFD   SP!, {R0,R2,R3,R12}\n"
 );
 button_pressed(button_code);
 asm volatile(
  "MOV     R1, R0\n"
  "MOV     R6, R0\n"
  "LDMFD   SP!, {R0,R2,R3,R12}\n"
  "LDMFD   SP!, {R4,LR}\n"
  "MOV     R7, R2\n"
  "LDR     R3, [R8]\n"
  "LDR     PC, =(_ZN9KeyCommon17SendKeyPressInputEii + 0x18 )\n"
 );
}

// ===========================================================================
// end.

