// ===========================================================================
// SamyConsole II constants
// ===========================================================================

#define APP_NAME	"SamyConsole II"
#define APP_VER		"1.1"
#define APP_YEAR	2015
#define APP_AUTHOR	"geo650"

#define MAIN_MODULE	"samyconsole2.so"

#ifndef MAX_PATH
#define MAX_PATH	256
#endif

#define KB_QUEUE_SIZE	128
#define AUTOREPEAT_DELAY 20
#define AUTOREPEAT_HOLD	100
#define AUTOREPEAT_STAGES 8

#define SCREEN_W	(1920/2)
#define SCREEN_H	(1080/2)
#define SCREEN_BPP	32
#define SCREEN_FLAGS	SDL_HWSURFACE

#define FONTBITMAP	"fonts8x8.png"
#define CHARWRASTER	8
#define CHARHRASTER	8
#define CHARWIDTH	8
#define CHARHEIGHT	8
#define CHARSHIFT	0

#define CURSORWIDTH	(CHARWIDTH - 2)
#define CURSORHEIGHT	2

#define LINEHEIGHT	(CHARHEIGHT + CURSORHEIGHT)

#define MAX_X		80
#define MAX_Y		30
#define CONSOLE_COLUMNS	80
#define CONSOLE_SHIFT	2
#define CONSOLE_LINES	24
#define BOTTOM_LINES	2
#define CONSOLE_LMARGIN	1
#define CONSOLE_RMARGIN	1

#define DELAY_THREAD	100

#define DEFAULT_HOST	"localhost"
#define DEFAULT_PORT	23
#define MAXDATASIZE	512
#define MAX_CBUFLEN	2000

#define DEFAULT_ALPHA	192
#define ALPHA_STEP	16

#define MOVE_STEP	5
enum
{
   MOVE_LEFT=1,
   MOVE_RIGHT,
   MOVE_UP,
   MOVE_DOWN
};
#define WINSIZE_W	(CONSOLE_LMARGIN + CONSOLE_COLUMNS + CONSOLE_RMARGIN) * CHARWIDTH
#define WINSIZE_H	(CONSOLE_SHIFT + CONSOLE_LINES + BOTTOM_LINES) * LINEHEIGHT
#define MAX_WIN_X	(SCREEN_W - WINSIZE_W)
#define MAX_WIN_Y	(SCREEN_H - WINSIZE_H)

typedef unsigned char BYTE;

// command types
#define	xEOF	(BYTE)236	// 0xEC End of file: EOF is already used...
#define	SUSP	(BYTE)237	// 0xED Suspend process
#define	ABORT	(BYTE)238	// 0xEE Abort process
#define EOR     (BYTE)239      	// 0xEF end of record (transparent mode)
#define	SE	(BYTE)240	// 0xF0 end sub negotiation
#define	NOP	(BYTE)241	// 0xF1 nop
#define	DM	(BYTE)242	// 0xF2 data mark--for connect. cleaning
//#define SYNCH	(BYTE)242	// 0xF2 for telfunc calls
#define	BREAK	(BYTE)243	// 0xF3 break
#define	IP	(BYTE)244	// 0xF4 interrupt process--permanently
#define	AO	(BYTE)245	// 0xF5 abort output--but let prog finish
#define	AYT	(BYTE)246	// 0xF6 are you there
#define	EC	(BYTE)247	// 0xF7 erase the current character
#define	EL	(BYTE)248	// 0xF8 erase the current line
#define	GA	(BYTE)249	// 0xF9 you may reverse the line
#define	SB	(BYTE)250	// 0xFA interpret as subnegotiation
#define	WILL	(BYTE)251	// 0xFB I will use option
#define	WONT	(BYTE)252	// 0xFC I won't use option
#define	DO	(BYTE)253	// 0xFD please, you use option
#define	DONT	(BYTE)254	// 0xFE you are not to use option
#define	IAC	(BYTE)255	// 0xFF interpret as command

#define BELL	7
#define BACKSPC	8
#define LF	10
#define CR	13
#define SI	15	// shift in
#define ESC	27

// telnet options
#define TELOPT_BINARY		(BYTE)0		// 0x00 8-bit data path
#define TELOPT_ECHO		(BYTE)1		// 0x01 echo
#define	TELOPT_RCP		(BYTE)2		// 0x02 prepare to reconnect
#define	TELOPT_SGA		(BYTE)3		// 0x03 suppress go ahead
#define	TELOPT_NAMS		(BYTE)4		// 0x04 approximate message size
#define	TELOPT_STATUS		(BYTE)5		// 0x05 give status
#define	TELOPT_TM		(BYTE)6		// 0x06 timing mark
#define	TELOPT_RCTE		(BYTE)7		// 0x07 remote controlled transmission and echo
#define TELOPT_NAOL		(BYTE)8		// 0x08 negotiate about output line width
#define TELOPT_NAOP		(BYTE)9		// 0x09 negotiate about output page size
#define TELOPT_NAOCRD		(BYTE)10	// 0x0A negotiate about CR disposition
#define TELOPT_NAOHTS		(BYTE)11	// 0x0B negotiate about horizontal tabstops
#define TELOPT_NAOHTD		(BYTE)12	// 0x0C negotiate about horizontal tab disposition
#define TELOPT_NAOFFD		(BYTE)13	// 0x0D negotiate about formfeed disposition
#define TELOPT_NAOVTS		(BYTE)14	// 0x0E negotiate about vertical tab stops
#define TELOPT_NAOVTD		(BYTE)15	// 0x0F negotiate about vertical tab disposition
#define TELOPT_NAOLFD		(BYTE)16	// 0x10 negotiate about output LF disposition
#define TELOPT_XASCII		(BYTE)17	// 0x11 extended ascic character set
#define	TELOPT_LOGOUT		(BYTE)18	// 0x12 force logout
#define	TELOPT_BM		(BYTE)19	// 0x13 byte macro
#define	TELOPT_DET		(BYTE)20	// 0x14 data entry terminal
#define	TELOPT_SUPDUP		(BYTE)21	// 0x15 supdup protocol
#define	TELOPT_SUPDUPOUTPUT	(BYTE)22	// 0x16 supdup output
#define	TELOPT_SNDLOC		(BYTE)23	// 0x17 send location
#define	TELOPT_TTYPE		(BYTE)24	// 0x18 terminal type
#define	TELOPT_EOR		(BYTE)25	// 0x19 end or record
#define	TELOPT_TUID		(BYTE)26	// 0x1A TACACS user identification
#define	TELOPT_OUTMRK		(BYTE)27	// 0x1B output marking
#define	TELOPT_TTYLOC		(BYTE)28	// 0x1C terminal location number
#define	TELOPT_3270REGIME	(BYTE)29	// 0x1D 3270 regime
#define	TELOPT_X3PAD		(BYTE)30	// 0x1E X.3 PAD
#define	TELOPT_NAWS		(BYTE)31	// 0x1F window size
#define	TELOPT_TSPEED		(BYTE)32	// 0x20 terminal speed
#define	TELOPT_LFLOW		(BYTE)33	// 0x21 remote flow control
#define TELOPT_LINEMODE		(BYTE)34	// 0x22 Linemode option
#define TELOPT_XDISPLOC		(BYTE)35	// 0x23 X Display Location
#define TELOPT_ENVIRON		(BYTE)36	// 0x24 Environment variables
#define	TELOPT_AUTHENTICATION	(BYTE)37	// 0x25 Authenticate
#define	TELOPT_ENCRYPT		(BYTE)38	// 0x26 Encryption option
#define TELOPT_NEW_ENVIRON	(BYTE)39	// 0x27 New-Environment variables (na podst.CommView)
#define	TELOPT_EXOPL		(BYTE)255	// 0xFF extended-options-list

#define MAX_TTYP     64
#define DEF_TTYP     "VT100"
#define MAX_HOSTLEN  255

// ===========================================================================
// end.

