// ===========================================================================
// Universal injector for loader.so
// ===========================================================================

#ifndef __UNIVERSAL_INJECTOR_C
#define __UNIVERSAL_INJECTOR_C

#include <stdio.h>
#include <dlfcn.h>
#include <errno.h>
#include <sys/mman.h>
#include <string.h>
#include "cacheflush.c"

// ---------------------------------------------------------------------------

#ifndef MAX_PATH
#define MAX_PATH	256
#endif

#define ARM_SINGLE_DATA_TRANSFER_COMMAND	0xE51FF004

// ---------------------------------------------------------------------------

int universal_injector(const char *path, char *main_module, char *main_path, char *src_function, int src_offset, char *dst_function, int dst_offset)
{
   int page1, page2;
   unsigned prev_injection, *handle, *ex_src_function, *ex_dst_function;
   char *ex_path, s[MAX_PATH];

   handle=NULL;
   if ( (handle = dlopen(NULL, RTLD_LAZY | RTLD_GLOBAL)) == NULL ) return 1;
   ex_src_function = dlsym(handle, src_function);
   if (ex_src_function == NULL ) return 2;
   dlclose(handle);
   sprintf(s, "%s%s", path, main_module);
   if ( (handle = dlopen(s, RTLD_NOW | RTLD_LOCAL | RTLD_NODELETE)) == NULL ) return 3;
   ex_dst_function = dlsym(handle, dst_function);
   if (ex_dst_function == NULL) return 4;
   if (main_path[0])
   {
      ex_path = dlsym(handle, main_path);
      if (ex_path == NULL ) return 5;
      else strcpy(ex_path, path);
   }
   dlclose(handle);
   page1 = ((unsigned)ex_src_function) & ~0x0FFF;
   mprotect((void *)page1, 8192, PROT_READ | PROT_WRITE | PROT_EXEC);
   if (ex_src_function[src_offset] == ARM_SINGLE_DATA_TRANSFER_COMMAND)
   {
      prev_injection = ex_src_function[src_offset + 1];
      page2 = ((unsigned)ex_dst_function) & ~0x0FFF;
      mprotect((void *) page2, 8192, PROT_READ | PROT_WRITE | PROT_EXEC);
      ex_dst_function[dst_offset]     = ex_src_function[src_offset];
      ex_dst_function[dst_offset + 1] = ex_src_function[src_offset + 1];
      mprotect((void *) page2, 8192, PROT_READ | PROT_EXEC);
      cacheflush(ex_dst_function + dst_offset, 8);
   }
   ex_src_function[src_offset] = ARM_SINGLE_DATA_TRANSFER_COMMAND;
   ex_src_function[src_offset + 1] = (unsigned)ex_dst_function;
   mprotect((void *)page1, 8192, PROT_READ | PROT_EXEC);
   cacheflush(ex_src_function + src_offset, 8);
   return 0;
}

#endif

// ===========================================================================
// end.

